#include "MUICatEdit.h"

#define HelpObject(node,obj) GroupObject,\
                                MUIA_HelpNode, node,\
                                Child, obj,\
                             End
APTR app=NULL;
APTR win=NULL;
APTR winfind=NULL;
APTR winrepl=NULL;
APTR listview=NULL;
APTR origview=NULL;
APTR boutonload=NULL;
APTR boutonsave=NULL;
APTR boutonquit=NULL;
APTR boutoncata=NULL;
APTR boutonfind=NULL;
APTR boutontout=NULL;
APTR boutonrepl=NULL;
APTR string=NULL;
APTR stringver=NULL;
APTR stringlang=NULL;
BOOL sortie=FALSE;
   
APTR boutonreplfirst=NULL;
APTR boutonreplnext =NULL;
APTR boutonreplall  =NULL;
APTR boutonreplquit =NULL;
APTR stringrepl     =NULL;
APTR stringby       =NULL;
APTR replcheck      =NULL;

APTR boutonfindfirst=NULL;
APTR boutonfindnext =NULL;
APTR boutonfindquit =NULL;
APTR stringfind     =NULL;
APTR findcheck      =NULL;

void OuvreInterface()
{
    app = ApplicationObject,
                MUIA_Application_Author     , "Alexandre FRANCOIS",
                MUIA_Application_Base       , "CATEDIT",
                MUIA_Application_Title      , "Catalog Editor",
                MUIA_Application_Version    , "$VER: MUICatEdit 1.0 (14.08.94)",
                MUIA_Application_Copyright  , " 1994 Alexandre FRANCOIS",
                MUIA_Application_Description, GetString( MSG_MUIDescription ),
                MUIA_Application_HelpFile   , "MUICatEdit.guide",
                SubWindow, win = WindowObject,
                        MUIA_Window_Title, GetString( MSG_WindowTitle ),
                        MUIA_Window_ID, MAKE_ID( 'W','I','N','0' ),
                        WindowContents, GroupObject,
                            MUIA_HelpNode, "Main-Window",
                            Child, ColGroup(2),
                                    Child, KeyLabel2(GetString(MSG_Version),'v'),
                                    Child, HelpObject("Version", stringver=KeyString(mc->mc_Version,arguments[1],'v')),
                                    Child, KeyLabel2(GetString(MSG_Language),'g'),
                                    Child, HelpObject("Language", stringlang=KeyString(mc->mc_Langage,arguments[1],'g')),
                            End,
                            Child, ColGroup(3),
                                Child, HelpObject("Find",boutonfind=KeyButton(GetString(MSG_Find),'F')),
                                Child, HelpObject("All",boutontout=KeyButton(GetString(MSG_All),'A')),
                                Child, HelpObject("Replace",boutonrepl=KeyButton(GetString(MSG_Replace),'R')),
                            End,
                            Child, listview = ListviewObject,
                                MUIA_HelpNode, "ListView",
                                MUIA_Listview_MultiSelect, MUIV_Listview_MultiSelect_Default,
                                MUIA_Listview_List, ListObject,
                                            InputListFrame,
                                    End,
                            End,
                            Child, HelpObject("Edit String", string=String("",arguments[1])),
                            Child, origview=ListviewObject,
                                MUIA_HelpNode, "Original string",
                                MUIA_Weight, 10,
                                MUIA_Listview_Input, FALSE,
                                MUIA_Listview_List, FloattextObject,
                                    MUIA_Frame, MUIV_Frame_ReadList,
                                End,
                            End,
                            Child, ColGroup(4),
                                Child, HelpObject("Load"  ,boutonload=KeyButton(GetString(MSG_Load),'L')),
                                Child, HelpObject("Save"  ,boutonsave=KeyButton(GetString(MSG_Save),'S')),
                                Child, HelpObject("CDFile",boutoncata=KeyButton(GetString(MSG_CDFile),'C')),
                                Child, HelpObject("Quit"  ,boutonquit=KeyButton(GetString(MSG_Quit),'Q')),
                            End,
                        End,
                End,
                SubWindow, winfind = WindowObject,
                        MUIA_Window_Title, GetString( MSG_WindowFindTitle ),
                        MUIA_Window_ID, MAKE_ID( 'W','I','N','1' ),
                        WindowContents, GroupObject,
                            MUIA_HelpNode, "Find Window",
                            Child, HCenter( (ColGroup(2),
                                Child, HelpObject("Case Sensitivity",findcheck=CheckMark(FALSE)),
                                Child, Label1(GetString(MSG_CaseSensitive)),
                                End)),
                            Child, ColGroup(2),
                                    Child, KeyLabel2(GetString(MSG_Find),'f'),
                                    Child, HelpObject("Find String", stringfind=KeyString("",arguments[1],'f')),
                            End,
                            Child, ColGroup(3),
                                Child, HelpObject("Find First",boutonfindfirst=KeyButton(GetString(MSG_FindFirst),'F')),
                                Child, HelpObject("Find Next",boutonfindnext =KeyButton(GetString(MSG_FindNext),'N')),
                                Child, HelpObject("Cancel Find",boutonfindquit =KeyButton(GetString(MSG_FindQuit),'Q')),
                            End,
                        End,
                End,
                SubWindow, winrepl = WindowObject,
                        MUIA_Window_Title, GetString( MSG_WindowReplaceTitle ),
                        MUIA_Window_ID, MAKE_ID( 'W','I','N','2' ),
                        WindowContents, GroupObject,
                            MUIA_HelpNode, "Replace Window",
                            Child, HCenter( (ColGroup(2),
                                Child, HelpObject("Case Sensitivity",replcheck=CheckMark(FALSE)),
                                Child, Label1(GetString(MSG_CaseSensitive)),
                                End)),
                            Child, ColGroup(2),
                                    Child, KeyLabel2(GetString(MSG_Replace),'r'),
                                    Child, HelpObject("Old String", stringrepl=KeyString("",arguments[1],'r')),
                                    Child, KeyLabel2(GetString(MSG_By),'y'),
                                    Child, HelpObject("New String", stringby=KeyString("",arguments[1],'y')),
                            End,
                            Child, ColGroup(4),
                                Child, HelpObject("Replace First", boutonreplfirst=KeyButton(GetString(MSG_ReplFirst),'F')),
                                Child, HelpObject("Replace Next", boutonreplnext =KeyButton(GetString(MSG_ReplNext),'N')),
                                Child, HelpObject("Replace Block", boutonreplall  =KeyButton(GetString(MSG_ReplAll) ,'A')),
                                Child, HelpObject("Cancel Replace", boutonreplquit =KeyButton(GetString(MSG_ReplQuit),'Q')),
                            End,
                        End,
                End,
        End;
    
    if(!app) FermeTout(GetString(MSG_ERROR_OPENINTERFACE),10);
    
    DoMethod(listview  ,MUIM_Notify,MUIA_List_Active,MUIV_EveryTime,app,2,MUIM_Application_ReturnID,ID_LIST2STR);
    DoMethod(string    ,MUIM_Notify,MUIA_String_Acknowledge,MUIV_EveryTime,app,2,MUIM_Application_ReturnID,ID_STR2LIST);
    DoMethod(stringver ,MUIM_Notify,MUIA_String_Acknowledge,MUIV_EveryTime,app,2,MUIM_Application_ReturnID,ID_STRVER);
    DoMethod(stringlang,MUIM_Notify,MUIA_String_Acknowledge,MUIV_EveryTime,app,2,MUIM_Application_ReturnID,ID_STRLANG);
 
    DoMethod(win, MUIM_Notify, MUIA_Window_CloseRequest, TRUE,
             app, 2, MUIM_Application_ReturnID,MUIV_Application_ReturnID_Quit);
    DoMethod(winfind, MUIM_Notify, MUIA_Window_CloseRequest, TRUE,
             app, 2,  MUIM_Application_ReturnID, ID_WINFIND);
    DoMethod(winrepl, MUIM_Notify, MUIA_Window_CloseRequest, TRUE,
             app, 2,  MUIM_Application_ReturnID, ID_WINREPL);
    DoMethod(boutonload, MUIM_Notify, MUIA_Pressed, FALSE,
             app, 2, MUIM_Application_ReturnID, ID_LOAD);
    DoMethod(boutonsave, MUIM_Notify, MUIA_Pressed, FALSE,
             app, 2, MUIM_Application_ReturnID, ID_SAVE);
    DoMethod(boutoncata, MUIM_Notify, MUIA_Pressed, FALSE,
             app, 2, MUIM_Application_ReturnID, ID_CDES);
    DoMethod(boutonfind, MUIM_Notify, MUIA_Pressed, FALSE,
             app, 2, MUIM_Application_ReturnID, ID_WINFIND);
    DoMethod(boutonrepl, MUIM_Notify, MUIA_Pressed, FALSE,
             app, 2, MUIM_Application_ReturnID, ID_WINREPL);
    DoMethod(boutonquit, MUIM_Notify, MUIA_Pressed, FALSE,
             app, 2, MUIM_Application_ReturnID, ID_QUIT);
    DoMethod(boutonfindquit, MUIM_Notify, MUIA_Pressed, FALSE,
             app, 2, MUIM_Application_ReturnID, ID_WINFIND);
    DoMethod(boutonreplquit, MUIM_Notify, MUIA_Pressed, FALSE,
             app, 2, MUIM_Application_ReturnID, ID_WINREPL);
    DoMethod(boutonfindfirst, MUIM_Notify, MUIA_Pressed, FALSE,
             app, 2, MUIM_Application_ReturnID, ID_FINDFIRST);
    DoMethod(boutonfindnext, MUIM_Notify, MUIA_Pressed, FALSE,
             app, 2, MUIM_Application_ReturnID, ID_FINDNEXT);
    DoMethod(boutonreplfirst, MUIM_Notify, MUIA_Pressed, FALSE,
             app, 2, MUIM_Application_ReturnID, ID_REPLFIRST);
    DoMethod(boutonreplnext,  MUIM_Notify, MUIA_Pressed, FALSE,
             app, 2, MUIM_Application_ReturnID, ID_REPLNEXT);
    DoMethod(boutonreplall,  MUIM_Notify, MUIA_Pressed, FALSE,
             app, 2, MUIM_Application_ReturnID, ID_REPLALL);
    DoMethod(boutontout, MUIM_Notify, MUIA_Pressed, FALSE,
             listview, 3, MUIM_List_Select, MUIV_List_Select_All, MUIV_List_Select_On, NULL);

    DoMethod(win, MUIM_Window_SetCycleChain, listview, string, boutonload, boutonsave, boutoncata, boutonquit, 
                                             stringver,stringlang,boutonfind,boutontout,boutonrepl, NULL);
    DoMethod(winfind, MUIM_Window_SetCycleChain, stringfind, boutonfindfirst, boutonfindnext,
                                                 boutonfindquit, findcheck, NULL);
    DoMethod(winrepl, MUIM_Window_SetCycleChain, stringrepl, stringby, boutonreplfirst, boutonreplnext,
                                                 boutonreplall,boutonreplquit,replcheck,NULL);
    DoMethod(listview,MUIM_List_Insert,mc->mc_Tableau,-1,MUIV_List_Insert_Bottom);
    set(listview ,MUIA_List_Active,0);

    set(win, MUIA_Window_Open, TRUE);
}

void FermeInterface()
{
    if(winfind) set(winfind, MUIA_Window_Open, FALSE);
    if(winrepl) set(winrepl, MUIA_Window_Open, FALSE);
    if(win)     set(win, MUIA_Window_Open, FALSE);
    if(app)     MUI_DisposeObject(app);
}

void ListUpdate(char *chaine,int num)
{
    set(listview,MUIA_List_Active,num);
    set(string,MUIA_String_Contents,chaine);
    set(origview,MUIA_Floattext_Text,ChaineNumero(mc,num));
}

STRPTR ChaineNumero(struct MonCatalogue *mc,LONG num)
{
    LONG compteur;
    struct CatChaine *cc;
    
    compteur=0;
    cc=mc->mc_TeteChaine.cc_Next;
    
    while(cc && (compteur<num))
    {
        compteur++;
        cc=cc->cc_Next;
    }
    return(cc->cc_Chaine);
}

void ToggleWindow(APTR win)
{
        LONG etat;
        
        get(win, MUIA_Window_Open, &etat);
        set(win, MUIA_Window_Open, !etat);
}

void GereInterface()
{
    ULONG signal;
    BOOL trouve;
    char  *chaine,*chaine2;
    char  *erreur=NULL;
    struct MonCatalogue *tempmc;
    LONG  oldnum,num,etat;
    char *(*comp[])(char *,char *)={ strstri, strstr };
    
    while(!sortie)
    {
        switch(DoMethod(app, MUIM_Application_Input, &signal))
        {
            case ID_QUIT:
            case MUIV_Application_ReturnID_Quit:
                    if(MUI_Request(app,win,0,NULL,GetString(MSG_OkCancel),GetString(MSG_WannaQuit)))
                        sortie=TRUE;
                    break;
            case ID_STR2LIST:
                    get(string,MUIA_String_Contents,&chaine);
                    get(listview,MUIA_List_Active,&num);
                    strcpy(mc->mc_Tableau[num],chaine);
                    DoMethod(listview, MUIM_List_Redraw, MUIV_List_Redraw_Active);
                    break;
            case ID_LIST2STR:
                    get(listview, MUIA_List_Active,&num);
                    set(string,MUIA_String_Contents, mc->mc_Tableau[num]);
                    set(origview,MUIA_Floattext_Text,ChaineNumero(mc,num));
                    break;
            case ID_STRVER:
                    get(stringver,MUIA_String_Contents,&chaine);
                    strcpy(mc->mc_Version, chaine);
                    break;
            case ID_STRLANG:
                    get(stringlang,MUIA_String_Contents,&chaine);
                    strcpy(mc->mc_Langage, chaine);
                    break;
            case ID_LOAD:
                    if(DemandeFichierEntree(fichier_entree))
                    {
                        if(!(tempmc=LitCatalogue((STRPTR)arguments[0],&erreur)))
                            AfficheErreur(erreur);
                        else
                        {
                            DoMethod(listview,MUIM_List_Clear);
                            LibereCatalogue(mc);
                            mc=tempmc;
                            DoMethod(listview,MUIM_List_Insert,mc->mc_Tableau,-1,MUIV_List_Insert_Bottom);
                            set(listview,MUIA_List_Active,0);
                            set(stringver,MUIA_String_Contents, mc->mc_Version);
                            set(stringlang,MUIA_String_Contents, mc->mc_Langage);
                        }
                    }
                    break;
            case ID_SAVE:
                    if(DemandeFichierSortie(fichier_sortie))
                        EcritCatalogue(mc,fichier_sortie);
                    break;
            case ID_CDES:
                    if(DemandeFichierSortie(fichier_sortie))
                        EcritDescription(mc,fichier_sortie);
                    break;
            case ID_WINFIND:
                    ToggleWindow(winfind);
                    break;
            case ID_WINREPL:
                    ToggleWindow(winrepl);
                    break;
            case ID_FINDFIRST:
                    get(stringfind, MUIA_String_Contents, &chaine);
                    if(!*chaine)
                        break;
                    get(findcheck, MUIA_Selected, &etat);
                    get(listview,  MUIA_List_Active,&oldnum);
                    if((num=ChercheMotMC(chaine, mc,0,comp[etat]))==-1)
                        num=oldnum;
                    ListUpdate(mc->mc_Tableau[num], num);
                    break;
            case ID_FINDNEXT:
                    get(stringfind, MUIA_String_Contents, &chaine);
                    if(!*chaine)
                        break;
                    get(findcheck, MUIA_Selected, &etat);
                    get(listview, MUIA_List_Active, &oldnum);
                    if((num=ChercheMotMC(chaine,mc,oldnum+1,comp[etat]))==-1)
                        num=oldnum;
                    ListUpdate(mc->mc_Tableau[num], num);
                    break;
            case ID_REPLFIRST:
                    get(stringrepl, MUIA_String_Contents, &chaine);
                    if(!*chaine)
                        break;
                    get(stringby, MUIA_String_Contents, &chaine2);
                    get(replcheck, MUIA_Selected, &etat);
                    get(listview,  MUIA_List_Active,&oldnum);
                    if((num=RemplaceMotMC(chaine,chaine2,mc,0,comp[etat]))==-1)
                        num=oldnum;
                    ListUpdate(mc->mc_Tableau[num], num);
                    DoMethod(listview, MUIM_List_Redraw, MUIV_List_Redraw_Active);
                    break;
            case ID_REPLNEXT:
                    get(stringrepl, MUIA_String_Contents, &chaine);
                    if(!*chaine)
                        break;
                    get(stringby, MUIA_String_Contents, &chaine2);
                    get(replcheck, MUIA_Selected, &etat);
                    get(listview, MUIA_List_Active, &oldnum);
                    if((num=RemplaceMotMC(chaine,chaine2,mc,oldnum+1,comp[etat]))==-1)
                        num=oldnum;
                    ListUpdate(mc->mc_Tableau[num], num);
                    DoMethod(listview, MUIM_List_Redraw, MUIV_List_Redraw_Active);
                    break;
            case ID_REPLALL:
                    get(stringrepl, MUIA_String_Contents, &chaine);
                    if(!*chaine)
                        break;
                    get(stringby, MUIA_String_Contents, &chaine2);
                    get(replcheck, MUIA_Selected, &etat);
                    trouve=FALSE;
                    num=MUIV_List_NextSelected_Start;
                    for(;;)
                    {
                        DoMethod(listview,MUIM_List_NextSelected,&num);
                        if(num==MUIV_List_NextSelected_End) break;
                        
                        trouve|=RemplaceToutMotMC(chaine,chaine2,mc->mc_Tableau[num],comp[etat]);
                    }
                    if(!trouve)
                        MUI_Request(app,win,0,NULL,GetString(MSG_Ok),GetString(MSG_NotFound),chaine);
                    else
                        DoMethod(listview, MUIM_List_Redraw, MUIV_List_Redraw_All);
                    break;
            default:
                    break;
        }
        if(!sortie && signal) Wait(signal);
    }
}
