#include "MUICatEdit.h"

struct Library *IffParseBase  = NULL;
struct DosBase *DosBase       = NULL;
struct Library *LocaleBase    = NULL;
struct Library *AslBase       = NULL;
struct Library *MUIMasterBase = NULL;

void OuvreBibliotheques(void)
{
    if(!(DosBase=(struct DosBase *) OpenLibrary("dos.library",39)))
        FermeTout(GetString(MSG_ERROR_OPENDOS_V39),10);
    if(!(LocaleBase=OpenLibrary("locale.library",38)))
        FermeTout(GetString(MSG_ERROR_OPENLOCALE_V38),10);
    if(!(IffParseBase=OpenLibrary("iffparse.library",0)))
        FermeTout(GetString(MSG_ERROR_OPENIFFPARSE),10);
    if(!(AslBase=OpenLibrary("asl.library",38)))
        FermeTout(GetString(MSG_ERROR_OPENASL_V38),10);
    if(!(MUIMasterBase=OpenLibrary(MUIMASTER_NAME,MUIMASTER_VMIN)))
        FermeTout(GetString(MSG_ERROR_OPENMUIMASTER),10);
}

void FermeBibliotheques(void)
{
    if(MUIMasterBase) CloseLibrary(MUIMasterBase);
    if(AslBase)       CloseLibrary(AslBase);
    if(IffParseBase)  CloseLibrary(IffParseBase);
    if(LocaleBase)    CloseLibrary(LocaleBase);
    if(DosBase)       CloseLibrary((struct Library *) DosBase);
}

void OuvreTout(void)
{
    OuvreBibliotheques();
    OuvreLocale();
    LitArguments();
    OuvreCatalogue();
    OuvreInterface();
}

void FermeTout(char *s,int error)
{
    FermeInterface();
    FermeCatalogue();
    LibereArguments();
    FermeLocale();
    FermeBibliotheques();

    if(s)
        printf("%s\n",s);
    exit(error);
}

void main(int argc,char *argv[])
{
    nbargs=argc;

    OuvreTout();
    
    GereInterface();
 
    FermeTout(NULL,0);
}
