#include "MUICatEdit.h"

BOOL DemandeFichierEntree(STRPTR chaine)
{
    int len;
    struct FileRequester *fr=NULL;
    
    if(!(fr=(struct FileRequester *) AllocAslRequestTags(ASL_FileRequest,
                                                         TAG_DONE)))
        FermeTout(GetString(MSG_ERROR_ALLOCREQUEST),10);
        
    if(AslRequestTags(fr,
                      ASLFR_PositiveText , GetString(MSG_Ok),
                      ASLFR_NegativeText , GetString(MSG_Cancel),
                      ASLFR_Locale       , NULL,
                      ASLFR_TitleText    , GetString(MSG_TitleAslRequest),
                      TAG_DONE ))
    {
        strcpy(chaine,fr->fr_Drawer);
        len=strlen(chaine);
        if((chaine[len-1]!=':') && (chaine[len-1]!='/'))
        {
            chaine[len]  ='/';
            chaine[len+1]='\0';
        }
        strcat(chaine,fr->fr_File);
        FreeAslRequest(fr);
        return(TRUE);
    }
    else
    {
        FreeAslRequest(fr);
        return(FALSE);
    }
}

BOOL DemandeFichierSortie(STRPTR chaine)
{
    int len;
    struct FileRequester *fr=NULL;
    
    if(!(fr=(struct FileRequester *) AllocAslRequestTags(ASL_FileRequest,
                                                         TAG_DONE)))
        FermeTout(GetString(MSG_ERROR_ALLOCREQUEST),10);

    if(AslRequestTags(fr,
                      ASLFR_Locale       , NULL,
                      ASLFR_DoSaveMode   , TRUE,
                      ASLFR_TitleText    , GetString(MSG_TitleAslRequest),
                      TAG_DONE ))
    {
        strcpy(chaine,fr->fr_Drawer);
        len=strlen(chaine);
        if((chaine[len-1]!=':') && (chaine[len-1]!='/'))
        {
            chaine[len]  ='/';
            chaine[len+1]='\0';
        }
        strcat(chaine,fr->fr_File);
        FreeAslRequest(fr);
        return(TRUE);
    }
    else
    {
        FreeAslRequest(fr);
        return(FALSE);
    }
}
