#include "MUICatEdit.h"

char *strstri(char *in,char *what)
{
    LONG i;
    
    for(i=0; i<=(LONG) strlen(in)-(LONG)strlen(what); i++)
        if(strnicmp(&in[i],what,strlen(what))==NULL)
            return(&in[i]);
    return(NULL);
}

LONG ChercheMotMC(STRPTR chaine, struct MonCatalogue *mc, LONG num, char *(*comp)(char *,char *))
{
    LONG compteur;
    struct CatChaine *cc;
    
    compteur=0;
    cc=mc->mc_TeteChaine.cc_Next;
    
    while(cc && (compteur<num))
    {
        compteur++;
        cc=cc->cc_Next;
    }
    while(cc && !comp(mc->mc_Tableau[compteur],chaine))
    {
        compteur++;
        cc=cc->cc_Next;
    }
    if(cc)
        return(compteur);
    else
    {
        MUI_Request(app,win,0,NULL,GetString(MSG_Ok),GetString(MSG_NotFound),chaine);
        return(-1);
    }
}

LONG RemplaceMotMC(STRPTR chaine1, STRPTR chaine2, struct MonCatalogue *mc, LONG num, char *(*comp)(char *,char *))
{
    LONG compteur;
    struct CatChaine *cc;
    char *gauche,*droite;
    char *p;

    if(!(gauche=malloc(sizeof(char)*arguments[1])))
    {
        AfficheErreur(GetString(MSG_ERROR_NOMEM));
        return(FALSE);
    }
    if(!(droite=malloc(sizeof(char)*arguments[1])))
    {
        free(gauche);
        AfficheErreur(GetString(MSG_ERROR_NOMEM));
        return(FALSE);
    }
    
    *gauche='\0';
    *droite='\0';
    compteur=0;
    cc=mc->mc_TeteChaine.cc_Next;
    
    while(cc && (compteur<num))
    {
        compteur++;
        cc=cc->cc_Next;
    }
    while(cc && !(p=comp(mc->mc_Tableau[compteur],chaine1)))
    {
        compteur++;
        cc=cc->cc_Next;
    }
    if(cc)
    {
        strmid(mc->mc_Tableau[compteur],gauche,1,p-mc->mc_Tableau[compteur]);
        strmid(mc->mc_Tableau[compteur],droite,p-mc->mc_Tableau[compteur]+strlen(chaine1)+1,strlen(mc->mc_Tableau[compteur])-strlen(chaine1)-(p-mc->mc_Tableau[compteur]));
        strcat(gauche,chaine2);
        strcat(gauche,droite);
        strcpy(mc->mc_Tableau[compteur],gauche);
        free(gauche);
        free(droite);
        return(compteur);
    }
    else
    {
        MUI_Request(app,win,0,NULL,GetString(MSG_Ok),GetString(MSG_NotFound),chaine1);
        free(gauche);
        free(droite);
        return(-1);
    }
}

BOOL RemplaceToutMotMC(STRPTR chaine1, STRPTR chaine2, char *where, char *(*comp)(char *,char *))
{
        BOOL trouve=FALSE;
        char *p;
        char *gauche,*droite;

        if(!(gauche=malloc(sizeof(char)*arguments[1])))
        {
            AfficheErreur(GetString(MSG_ERROR_NOMEM));
            return(FALSE);
        }
        if(!(droite=malloc(sizeof(char)*arguments[1])))
        {
            free(gauche);
            AfficheErreur(GetString(MSG_ERROR_NOMEM));
            return(FALSE);
        }
        
        *gauche='\0';
        *droite='\0';
        
        while(p=comp(where,chaine1))
        {
            trouve=TRUE;
            strmid(where,gauche,1,p-where);
            strmid(where,droite,p-where+strlen(chaine1)+1,strlen(where)-strlen(chaine1)-(p-where));
            strcat(gauche,chaine2);
            strcat(gauche,droite);
            strcpy(where,gauche);
            where=p+strlen(chaine2)-1;
        }
        free(gauche);
        free(droite);
        return(trouve);
}
